package com.yem.wm.task;

import kd.bos.context.RequestContext;
import kd.bos.dataentity.OperateOption;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.operate.result.OperationResult;
import kd.bos.exception.KDException;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.schedule.executor.AbstractTask;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.bos.servicehelper.operation.OperationServiceHelper;

import java.util.Map;

/**
 * 获取调拨价
 */

public class GetTransferCostPriceTask extends AbstractTask {
    @Override
    public void execute(RequestContext requestContext, Map<String, Object> map) throws KDException {
        DynamicObject[] orders = BusinessDataServiceHelper.load("yem_transferorder", "id", new QFilter[]{new QFilter("yem_iseas", QCP.not_equals, true)});
        OperationResult operationResult = OperationServiceHelper.executeOperate("getprice", "yem_transferorder", orders, OperateOption.create());
    }
}
